/*
 *	Copyright (c) 2024 Scott Duensing, scott@kangaroopunch.com
 *
 *	Permission is hereby granted, free of charge, to any person obtaining a copy
 *	of this software and associated documentation files (the "Software"), to deal
 *	in the Software without restriction, including without limitation the rights
 *	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *	copies of the Software, and to permit persons to whom the Software is
 *	furnished to do so, subject to the following conditions:
 *
 *	The above copyright notice and this permission notice shall be included in
 *	all copies or substantial portions of the Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *	SOFTWARE.
 */


#include "oc_compare.h"
#include "state.h"
#include "interpreter.h"
#include "variable.h"
#include "object.h"
#include "story.h"
#include "portme.h"
#include "messages.h"
#include "memory.h"


void opcodes_je(void) {
	uint16_t a = __state.operands[0];
	int8_t   i;

	for (i=1; i<__state.operandCount; i++) {
		if (a == __state.operands[i]) {
			interpreterDoBranch(1);
			return;
		}
	}

	interpreterDoBranch(0);
}


void opcodes_dec_chk(void) {
	int16_t val = variableLoad(__state.operands[0]);
	val--;
	variableStore(__state.operands[0], val);
	interpreterDoBranch(((int16_t)val < (int16_t)__state.operands[1]) ? 1 : 0);
}


void opcodes_inc_chk(void) {
	int16_t val = variableLoad(__state.operands[0]);
	val++;
	variableStore(__state.operands[0], val);
	interpreterDoBranch(((int16_t)val > (int16_t)__state.operands[1]) ? 1 : 0);
}


void opcodes_jg(void) {
	interpreterDoBranch(((int16_t)__state.operands[0] > (int16_t)__state.operands[1]) ? 1 : 0);
}


void opcodes_jin(void) {
	uint16_t objId    = __state.operands[0];
	uint16_t parentId = __state.operands[1];
	uint32_t objPtr   = objectPointerGet(objId);

	// Zork 1 will trigger this on "go X" where "x" isn't a direction.
	if (objPtr == 0) return;

	if (storyVersion() <= 3) {
		interpreterDoBranch((ZPEEK(objPtr + 4) == parentId) ? 1 : 0);
	} else {
		portDie(MSG_UNIMPLEMENTED);
	}
}


void opcodes_jl(void) {
	interpreterDoBranch(((int16_t)__state.operands[0] < (int16_t)__state.operands[1]) ? 1 : 0);
}


void opcodes_jump(void) {
	__state.pc = __state.pc + ((int16_t)__state.operands[0]) - 2;
}


void opcodes_jz(void) {
	interpreterDoBranch((__state.operands[0] == 0) ? 1 : 0);
}


void opcodes_test(void) {
	interpreterDoBranch(((__state.operands[0] & __state.operands[1]) == __state.operands[1]) ? 1 : 0);
}

